Subject: [PATCH v3 0/2] [RFC] push: allow delete one level ref

From: "ZheNing Hu via GitGitGadget" <[email-masked]>
Date: Mon, 27 Feb 2023 01:57:00 +0000

This might be an odd request: allow git push to delete one level refs like
"ref/foo".

Some users on my side often push "refs/for/master" to the remote for code
review, but due to a user's typo, "refs/master" is pushed to the remote.

Pushing a one level ref like "refs/foo" should not have been successful, but
since my server side directly updated the ref during the proc-receive-hook
phase of git receive-pack, "refs/foo" was mistakenly left at on the server.

But for some reasons, users cannot delete this special branch through "git
push -d".

First, I executed git update-ref --stdin inside my proc-receive-hook to
delete the branch. As a result, update-ref reported an error: "cannot lock
ref 'refs/foo': reference already exists".

So I tried GIT_TRACKET_PACKET to debug and found that git push did not seem
to pass the correct ref old-oid, which is why update-ref reported an error.

"18:13:41.214872 pkt-line.c:80           packet: receive-pack< 0000000000000000000000000000000000000000 0000000000000000000000000000000000000000 refs/foo\0 report-status-v2 side-band-64k object-format=sha1 agent=git/2.39.0.227.g262c45b6a1"

Tracing it back, the check_ref() in the git push link didn't record the
old-oid for the remote "refs/foo".

At the same time, the server update() process will reject the one level ref
by default and return a "funny refname" error.

It is worth mentioning that since I deleted the branch, the error message
returned here is "refusing to create funny ref 'refs/foo' remotely", which
is also worth fixing.

So this patch series do:

v1.

 1. fix funny refname error message from "create" to "update".
 2. let server allow delete one level ref.
 3. let client pass correct one level ref old-oid.

v2.

 1. fix code style.

v3.

 1. clarify in the docs why single-level refs are allowed to be deleted but
    not created/updated.

ZheNing Hu (2):
  receive-pack: fix funny ref error messsage
  [RFC] push: allow delete single-level ref

 builtin/receive-pack.c |  6 ++++--
 connect.c              |  3 ++-
 t/t5516-fetch-push.sh  | 12 ++++++++++++
 3 files changed, 18 insertions(+), 3 deletions(-)

base-commit: dadc8e6dacb629f46aee39bde90b6f09b73722eb
Published-As: https://github.com/gitgitgadget/git/releases/tag/pr-1465%2Fadlternative%2Fzh%2Fdelete-one-level-ref-v3
Fetch-It-Via: git fetch https://github.com/gitgitgadget/git pr-1465/adlternative/zh/delete-one-level-ref-v3
Pull-Request: https://github.com/gitgitgadget/git/pull/1465

Range-diff vs v2:

 1:  214a2b662e3 = 1:  857d2435caf receive-pack: fix funny ref error messsage
 2:  966cb49c388 ! 2:  4dc75f5b961 [RFC] push: allow delete one level ref
     @@ Metadata
      Author: ZheNing Hu <[email-masked]>
      
       ## Commit message ##
     -    [RFC] push: allow delete one level ref
     +    [RFC] push: allow delete single-level ref
      
     -    Git will reject the deletion of one level refs e,g. "refs/foo"
     -    through "git push -d", however, some users want to be able to
     -    clean up these branches that were created unexpectedly on the
     -    remote.
     +    We discourage the creation/update of single-level refs
     +    because some upper-layer applications only work in specified
     +    reference namespaces, such as "refs/heads/*" or "refs/tags/*",
     +    these single-level refnames may not be recognized. However,
     +    we still hope users can delete them which have been created
     +    by mistake.
      
          Therefore, when updating branches on the server with
          "git receive-pack", by checking whether it is a branch deletion
          operation, it will determine whether to allow the update of
     -    one level refs. This avoids creating/updating such one level
     -    branches, but allows them to be deleted.
     +    a single-level refs. This avoids creating/updating such
     +    single-level refs, but allows them to be deleted.
      
          On the client side, "git push" also does not properly fill in
     -    the old-oid of one level refs, which causes the server-side
     +    the old-oid of single-level refs, which causes the server-side
          "git receive-pack" to think that the ref's old-oid has changed
     -    when deleting one level refs, this causes the push to be rejected.
     -
     -    So the solution is to fix the client to be able to delete
     -    one level refs by properly filling old-oid.
     +    when deleting single-level refs, this causes the push to be
     +    rejected. So the solution is to fix the client to be able to
     +    delete single-level refs by properly filling old-oid.
      
          Signed-off-by: ZheNing Hu <[email-masked]>

-- 
gitgitgadget